;;; -------------------------------------------------------------------------------------------------------------------------------------;
;;;   zoomm_final_version.lsp
;;;
;;;   Copyright  2000 - 2016 by Alexander Leevy 
;;;
;;;    zoomm -   floating viewport   2.302-68 (     .lsp    )!!! 
;;;        .lsp    Autodesk Autocad 2007 (  )....  Enjoy! 29.11.2016 
;;; -------------------------------------------------------------------------------------------------------------------------------------;

;;;      zoomm
(defun c:zoomm (/ *error* lst N Ni obj Key M pt H back b)
  (defun *error* (a)
    (redraw)
    (grtext)
    (setvar "MODEMACRO" "")
    (princ)
  )					; *error*
  (prompt
    "\n ZOOMM  2000 - 2016 by Alexander Leevy\n   \"zoomm\"  AutoCAD 2007 (  )\n     floating viewport   2.302-68\n"
  )

  (setvar "cmdecho" 0)

  (if (= (sslength (ssget "X" (list (cons 0 "VIEWPORT")))) 1)
    (progn (alert "!!!\n\n floating viewport(s)!")
	   (exit)
    )
  )
  (setvar "tilemode" 0)
  (command "_.pspace")
  (while (null obj)
    (setq obj (entsel "\n viewport  :"))
    (if	obj
      (if (/= "VIEWPORT" (cdr (assoc 0 (entget (car obj)))))
	(setq obj nil)
      )
    )
  )					;while
  (setq obj (entget (car obj)))
  (if (<= (cdr (assoc 68 obj)) 0)
    (command "_.-layer"
	     "_u"
	     (cdr (assoc 8 obj))
	     ""
	     "_.mview"
	     "_on"
	     (cdr (assoc -1 obj))
	     ""
    )
  )
  (command "_.osnap"
	   "_off"
	   "_.zoom"
	   "_c"
	   (trans (cdr (assoc 10 obj)) 0 1)
	   (max (cdr (assoc 40 obj)) (cdr (assoc 41 obj)))
	   "_.mspace"
	   "_.cvport"
	   (cdr (assoc 69 obj))
  )
  (if (/= 0 (getvar "viewmode"))
    (progn (alert "!\n\n  !!!") (exit))
  )
  (prompt
    "\n 8,2,6,4 - , \"+\"- , \"-\"-  , Enter -  \n"
  )
					;lst =   2.302-68        :-) 
  (setq	lst (list 0.0001
		  0.0002
		  0.0005
		  0.001
		  0.00125
		  0.002
		  0.0025
		  0.005
		  0.01
		  (/ 1.0 75.0)
		  0.02
		  0.025
		  0.04
		  0.05
		  (/ 1.0 15.0)
		  0.1
		  0.2
		  0.25
		  0.4
		  0.5
		  1.0
		  2.0
		  2.5
		  4.0
		  5.0
		  10.0
		  20.0
		  40.0
		  50.0
		  100.0
	    )
	Ni  0
	N   (/ (cdr (assoc 41 obj)) (getvar "viewsize"))
  )					;setq
  (cond
    ((<= N (car lst)) (setq N 0))
    ((>= N (last lst)) (setq N (1- (length lst))))
    ((> N (car lst))
     (progn (while (< (nth Ni lst) N) (setq Ni (1+ Ni)))
	    (setq N Ni)
     )
    )
  )					;cond
  (setq	pt   (trans (getvar "viewctr") 1 2)
	back (list (getvar "viewctr") (getvar "viewsize"))
	b    T
  )
  (defun *error* (a)
    (princ (strcat "\n !!! " a))
    (princ)
  )					;Esc
  (while obj
    (if	b
      (progn
	(cond
	  ((> (nth N lst) 1.0)
	   (setq M (strcat (rtos (nth N lst) 2 8) ":1"))
	  )
	  ((< (nth N lst) 1.0)
	   (setq M (strcat "1:" (rtos (/ 1.0 (nth N lst)) 2 8)))
	  )
	  ((= (nth N lst) 1.0) (setq M "1:1"))
	)				;cond
	(prompt (strcat "\r  " M "\t\t\t\t "))
	(command "_.zoom"
		 "_c"
		 (trans pt 2 1)
		 (strcat (rtos (nth N lst) 2 8) "xp")
					;"xp" -  , .. xp 
	)
      )					;progn
    )					;if	
    (setq Key (last (GRREAD nil 14 1)))

    (setq H (/ 1.0 (nth N lst)))			; H -      8,2,6,4 ...      -> (setq H   (* (getvar "viewsize") 0.01))


    (cond
      ((= 13 Key)
       (progn (prompt (strcat "\r  " M "            \n"))
	      (command "_.pspace" "_.zoom" "_p")
	      (setq obj nil)
       )
      )					;
      ((= 43 Key)
       (if (< N (1- (length lst)))
	 (setq N (1+ N)
	       b T
	 )
	 (setq b nil)
       )
      )					;. 
      ((= 45 Key)
       (if (> N 0)
	 (setq N (1- N)
	       b T
	 )
	 (setq b nil)
       )
      )					;. 
      ((= 56 Key)
       (setq pt	(list (nth 0 pt) (+ (nth 1 pt) H))
	     b	T
       )
      )					;
      ((= 50 Key)
       (setq pt	(list (nth 0 pt) (- (nth 1 pt) H))
	     b	T
       )
      )					;
      ((= 54 Key)
       (setq pt	(list (+ (nth 0 pt) H) (nth 1 pt))
	     b	T
       )
      )					;
      ((= 52 Key)
       (setq pt	(list (- (nth 0 pt) H) (nth 1 pt))
	     b	T
       )
      )					;
    )					;cond
  )					;while
  (princ)
)					;zoomm 

